import type { HTMLAttributes, ImgHTMLAttributes, Ref } from 'vue';
import type { ElementScriptTrigger } from '../types.js';
import ScriptAriaLoadingIndicator from './ScriptAriaLoadingIndicator.vue.js';
export type YoutubeThumbnailSize = '1' | '2' | '3' | 'default' | 'mq1' | 'mq2' | 'mq3' | 'mqdefault' | '0' | 'hq1' | 'hq2' | 'hq3' | 'hqdefault' | 'sd1' | 'sd2' | 'sd3' | 'sddefault' | 'hq720' | 'maxresdefault';
type __VLS_Props = {
    placeholderAttrs?: ImgHTMLAttributes;
    rootAttrs?: HTMLAttributes;
    aboveTheFold?: boolean;
    trigger?: ElementScriptTrigger;
    videoId: string;
    playerVars?: YT.PlayerVars;
    width?: number;
    height?: number;
    /**
     * Whether to use youtube-nocookie.com for embedding.
     *
     * @default false
     */
    cookies?: boolean;
    playerOptions?: YT.PlayerOptions;
    thumbnailSize?: YoutubeThumbnailSize;
    webp?: boolean;
};
declare const rootEl: Ref<any, any>;
declare const youtubeEl: Ref<any, any>;
declare const ready: Ref<boolean, boolean>;
declare const status: Ref<import("@unhead/vue").UseScriptStatus, import("@unhead/vue").UseScriptStatus>;
declare const rootAttrs: import("vue").ComputedRef<HTMLAttributes>;
declare const placeholder: import("vue").ComputedRef<string>;
declare const placeholderAttrs: import("vue").ComputedRef<Omit<ImgHTMLAttributes, "style" | "src" | "loading" | "onLoad" | "alt"> & Omit<{
    src: string;
    alt: string;
    loading: "eager" | "lazy";
    style: {
        width: string;
        objectFit: "contain";
        height: string;
    };
    onLoad(payload: Event): void;
}, "style" | "src" | "loading" | "onLoad" | "alt"> & {
    style: string | false | import("vue").StyleValue[] | {
        width: string;
        objectFit: "contain";
        height: string;
    } | (Omit<import("vue").CSSProperties, "width" | "height" | "objectFit"> & Omit<{
        width: string;
        objectFit: "contain";
        height: string;
    }, "width" | "height" | "objectFit"> & {
        width: string | number | (string & {});
        height: string | number | (string & {});
        objectFit: "fill" | "none" | "-moz-initial" | "inherit" | "initial" | "revert" | "revert-layer" | "unset" | "contain" | "cover" | "scale-down";
    });
    src: string;
    loading: "eager" | "lazy";
    onLoad: ((payload: Event) => void) | ((payload: Event) => void);
    alt: string;
}>;
declare const __VLS_ctx: InstanceType<__VLS_PickNotAny<typeof __VLS_self, new () => {}>>;
declare var __VLS_1: {
    placeholder: any;
}, __VLS_3: {}, __VLS_8: {}, __VLS_10: {}, __VLS_12: {};
type __VLS_Slots = __VLS_PrettifyGlobal<__VLS_OmitStringIndex<typeof __VLS_ctx.$slots> & {
    placeholder?: (props: typeof __VLS_1) => any;
} & {
    loading?: (props: typeof __VLS_3) => any;
} & {
    awaitingLoad?: (props: typeof __VLS_8) => any;
} & {
    error?: (props: typeof __VLS_10) => any;
} & {
    default?: (props: typeof __VLS_12) => any;
}>;
declare const __VLS_self: import("vue").DefineComponent<__VLS_Props, {
    ScriptAriaLoadingIndicator: typeof ScriptAriaLoadingIndicator;
    rootEl: typeof rootEl;
    youtubeEl: typeof youtubeEl;
    ready: typeof ready;
    status: typeof status;
    rootAttrs: typeof rootAttrs;
    placeholder: typeof placeholder;
    placeholderAttrs: typeof placeholderAttrs;
}, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    error: (e: YT.OnErrorEvent, target: YT.Player) => any;
    ready: (e: YT.PlayerEvent) => any;
    "state-change": (e: YT.OnStateChangeEvent, target: YT.Player) => any;
    "playback-quality-change": (e: YT.OnPlaybackQualityChangeEvent, target: YT.Player) => any;
    "playback-rate-change": (e: YT.OnPlaybackRateChangeEvent, target: YT.Player) => any;
}, string, import("vue").PublicProps, Readonly<__VLS_Props> & Readonly<{
    onError?: ((e: YT.OnErrorEvent, target: YT.Player) => any) | undefined;
    onReady?: ((e: YT.PlayerEvent) => any) | undefined;
    "onState-change"?: ((e: YT.OnStateChangeEvent, target: YT.Player) => any) | undefined;
    "onPlayback-quality-change"?: ((e: YT.OnPlaybackQualityChangeEvent, target: YT.Player) => any) | undefined;
    "onPlayback-rate-change"?: ((e: YT.OnPlaybackRateChangeEvent, target: YT.Player) => any) | undefined;
}>, {
    trigger: ElementScriptTrigger;
    width: number;
    height: number;
    playerVars: YT.PlayerVars;
    cookies: boolean;
    thumbnailSize: YoutubeThumbnailSize;
    webp: boolean;
}, {}, {}, {}, string, import("vue").ComponentProvideOptions, false, {}, any>;
declare const __VLS_component: import("vue").DefineComponent<__VLS_Props, {
    player: Ref<YT.Player | undefined, YT.Player | undefined>;
}, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    error: (e: YT.OnErrorEvent, target: YT.Player) => any;
    ready: (e: YT.PlayerEvent) => any;
    "state-change": (e: YT.OnStateChangeEvent, target: YT.Player) => any;
    "playback-quality-change": (e: YT.OnPlaybackQualityChangeEvent, target: YT.Player) => any;
    "playback-rate-change": (e: YT.OnPlaybackRateChangeEvent, target: YT.Player) => any;
}, string, import("vue").PublicProps, Readonly<__VLS_Props> & Readonly<{
    onError?: ((e: YT.OnErrorEvent, target: YT.Player) => any) | undefined;
    onReady?: ((e: YT.PlayerEvent) => any) | undefined;
    "onState-change"?: ((e: YT.OnStateChangeEvent, target: YT.Player) => any) | undefined;
    "onPlayback-quality-change"?: ((e: YT.OnPlaybackQualityChangeEvent, target: YT.Player) => any) | undefined;
    "onPlayback-rate-change"?: ((e: YT.OnPlaybackRateChangeEvent, target: YT.Player) => any) | undefined;
}>, {
    trigger: ElementScriptTrigger;
    width: number;
    height: number;
    playerVars: YT.PlayerVars;
    cookies: boolean;
    thumbnailSize: YoutubeThumbnailSize;
    webp: boolean;
}, {}, {}, {}, string, import("vue").ComponentProvideOptions, false, {}, any>;
declare const _default: __VLS_WithSlots<typeof __VLS_component, __VLS_Slots>;
export default _default;
type __VLS_WithSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
